/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomDOMApplicationCache_H__
#define __GdomDOMApplicationCache_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomDOMApplicationCache GdomDOMApplicationCache;
typedef struct _GdomDOMApplicationCacheClass GdomDOMApplicationCacheClass;


#define GDOM_TYPE_DOM_APPLICATION_CACHE            (gdom_dom_application_cache_get_type())
#define GDOM_DOM_APPLICATION_CACHE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_DOM_APPLICATION_CACHE, GdomDOMApplicationCache))
#define GDOM_DOM_APPLICATION_CACHE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_DOM_APPLICATION_CACHE, GdomDOMApplicationCache)Class)
#define GDOM_IS_DOM_APPLICATION_CACHE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_DOM_APPLICATION_CACHE))
#define GDOM_IS_DOM_APPLICATION_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_DOM_APPLICATION_CACHE))
#define GDOM_DOM_APPLICATION_CACHE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_DOM_APPLICATION_CACHE, GdomDOMApplicationCacheClass))

typedef struct _GdomDOMApplicationCachePrivate GdomDOMApplicationCachePrivate;

struct _GdomDOMApplicationCache {
    GdomDOMObject parent_instance;
    GdomDOMApplicationCachePrivate *priv;
};

struct _GdomDOMApplicationCacheClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_dom_application_cache_get_type (void);

WEBKIT_API void
gdom_dom_application_cache_update (GdomDOMApplicationCache *thiz);

WEBKIT_API void
gdom_dom_application_cache_swap_cache (GdomDOMApplicationCache *thiz);

WEBKIT_API gchar *
gdom_dom_application_cache_item (GdomDOMApplicationCache *thiz, gulong index);


/* XXX TODO: custom function gdom_dom_application_cache_add */


/* XXX TODO: custom function gdom_dom_application_cache_remove */


/* XXX TODO: custom function gdom_dom_application_cache_add_event_listener */


/* XXX TODO: custom function gdom_dom_application_cache_remove_event_listener */


/* XXX TODO: custom function gdom_dom_application_cache_dispatch_event */

G_END_DECLS

#endif /* __GdomDOMApplicationCache_H__ */
